#define _CRT_SECURE_NO_DEPRECATE 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <windows.h>

#include "audioeffectx.h"
#include "vstcontrols.h"


// ============================================================================================
// ݌v̋L
// ============================================================================================
#define MY_VST_VENDOR       "test vendor"        //(x_[)
#define MY_VST_VERSION      1                    //VSTo[W
#define MY_VST_PRODUCT_NAME "Sample VST GUI"   //VST̐i
#define MY_VST_NAME         "GUI"              //VST̖O

#define MY_VST_INPUT_NUM   2 //͐Bm=1AXeI=2
#define MY_VST_OUTPUT_NUM  2 //o͐Bmo=1AXeIo=2

#define MY_VST_UNIQUE_ID  'SMPL' //j[NID
                                 //Jꍇ͈ȉURLŔsꂽj[NID͂B
                                 //http://ygrabit.steinberg.de/~ygrabit/public_html/index.html

#define MY_VST_PRESET_NUM    1 //vZbgvO̐
#define MY_VST_PARAMETER_NUM 2 //p[^̐

#define MYVST_VOLUME_L 0
#define MYVST_VOLUME_R 1
// ============================================================================================
// VST GUINX
// ============================================================================================
class VstGui5 : public AEffGUIEditor, CControlListener
{
public:
	VstGui5 (void* effect);
	virtual ~VstGui5 ();

	// GUIWindowJƂƕƂɏs֐
	virtual bool open (void *ptr);
	virtual void close ();

	// ̏AChԂ̍ۂɌĂяo֐
	// GUI`̍XVsB
	// 炭100~bƂɌĂяoB
	virtual void idle ();

	// {^܂ݓꂽƂɏs֐
	// ̓eLXgx݂̂̂߁AׂƂ͂ȂA
	// valueChanged()֐͕KI[o[ChȂ΂ȂȂB
	virtual void valueChanged (CDrawContext *pContext, CControl *pControl) {};

protected:
	int i;
	// eLXgx
	CTextLabel* textLabel;
};

VstGui5::VstGui5 (void* effect)
: AEffGUIEditor ((AudioEffect*)effect)
{
	// p̂ɂrectϐB
	// rectϐGUIWindowsTCYݒ肷B
	// (ݒsȂWindowJȂ)
	rect.left   = 0;
	rect.top    = 0;
	rect.right  = 512;
	rect.bottom = 256;

	i = 0;
}

VstGui5::~VstGui5 ()
{
}

bool VstGui5::open (void *ptr)
{
	// ܂͌p̊֐Ăяo(K{)
	AEffGUIEditor::open (ptr);

	// Ƀt[(CFrame)쐬B
	// {^܂ݓ͂̃t[̏ɔzu`ɂȂ
	// łWindowƓTCỸt[쐬Ă
	CRect size (rect.left, rect.top, rect.right, rect.bottom);

	CFrame* cframe = new CFrame (size, ptr, this);
	// 쐬t[͌pɂframeϐɒlۑKvB
	this->frame = cframe;

	// -----------------------------------------------------------------
	// eLXgx̑傫ݒ
 	CRect textsize (0, 0, 80, 25);

	// eLXgẍʒuݒ
	textsize.offset (16, 16);

	// eLXgx쐬
	textLabel = new CTextLabel(textsize, "TextLabel", NULL, kLeft);

	// eLXgxframeɒǉ
	frame->addView (textLabel);

	// ɖ肪ȂtrueԂ
	return true;
}

void VstGui5::close ()
{
	// framedelete邱ƂYȂ悤ɂ
	if (frame)
	{
		delete frame;
	}
	frame = 0;
}

void VstGui5::idle ()
{
	// ܂͌p̊֐Ăяo(K{)
	AEffGUIEditor::idle ();

	// VSTGUIŗL̏Lڂ

//	static int i = 0;
	char text[256];

	sprintf_s(text, 256,"%d", i);

	//eLXgx̕ݒ肷
	textLabel->setText (text);

	// eLXgx̕`XV
	textLabel->setDirty();

	i++;
}

// ============================================================================================
// VST̊{ƂȂNX
// ============================================================================================
class MyVstGui5 : public AudioEffectX
{
public:
	MyVstGui5 (audioMasterCallback audioMaster);
	~MyVstGui5 ();

	// M郁o[֐
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);
};

// ============================================================================================
// VST̂𐶐邽߂̊֐
// ============================================================================================
AudioEffect* createEffectInstance (audioMasterCallback audioMaster)
{
	//newłVST𐶐|C^Ԃ
	return new MyVstGui5 (audioMaster);
}

// ============================================================================================
// RXgN^AfXgN^(VST̏AILq)
// ============================================================================================
MyVstGui5::MyVstGui5 (audioMasterCallback audioMaster)
: AudioEffectX (audioMaster, MY_VST_PRESET_NUM, MY_VST_PARAMETER_NUM)
{
	//VST̏sB

	//ȉ̊֐Ăяoē͐Ao͐̏ݒ肷B
	//KĂяoȂ΂ȂȂB
	setNumInputs (MY_VST_INPUT_NUM);    //͐̐ݒ
	setNumOutputs (MY_VST_OUTPUT_NUM);  //o͐̐ݒ
	setUniqueID (MY_VST_UNIQUE_ID);     //j[NID̐ݒ

	isSynth (false);          //VSTSynthǂ̃tOݒB
	                         //Synth̏ꍇctrueAEffectoȑꍇcfalse

	canProcessReplacing ();  //VST\ǂ̃tOݒB
	                         //sȂVST͂Ȃ̂ŕK̊֐ĂяoB

	// GUIݒ肷
	editor = new VstGui5(this);

	//VST̃p[^B
}

MyVstGui5::~MyVstGui5 ()
{
	//VST̏IB
	//VSTł͓Ɏs鏈͂ȂB

	// GUIdeleteȂĂۂ
}

// ============================================================================================
// M郁o[֐
// ============================================================================================
void MyVstGui5::processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames)
{
	float *inL = inputs[0]; // p
	float *inR = inputs[1]; // Ep
	float *outL = outputs[0]; //o p
	float *outR = outputs[1]; //o Ep

	for (int i = 0; i <sampleFrames ; i++)
	{
		// ͂̂܂܏o͂
		outL[i] = inL[i];
		outR[i] = inR[i];
	}
}

